version: '3.3'
services:

  # Infrastructure
  # ============================================================================
  # Config server
  config-server:
    image: springcommunity/spring-petclinic-config-server
    container_name: config-server
    ports:
     - 8888:8888

  # Discovery service
  discovery-server:
    image: springcommunity/spring-petclinic-discovery-server
    container_name: discovery-server
    depends_on:
      - config-server
    entrypoint: ["./dockerize","-wait=tcp://config-server:8888","-timeout=300s","--","java", "org.springframework.boot.loader.JarLauncher"]
    ports:
     - 8761:8761

  # Services
  # ============================================================================
  # Customers service
  customers-service:
    image: springcommunity/spring-petclinic-customers-service
    container_name: customers-service
    depends_on:
     - config-server
     - discovery-server
    entrypoint: ["./dockerize","-wait=tcp://discovery-server:8761","-timeout=300s","--","java", "org.springframework.boot.loader.JarLauncher"]
    ports:
    - 8081:8081

  # Visits service
  visits-service:
    image: springcommunity/spring-petclinic-visits-service
    container_name: visits-service
    depends_on:
     - config-server
     - discovery-server
    entrypoint: ["./dockerize","-wait=tcp://discovery-server:8761","-timeout=300s","--","java", "org.springframework.boot.loader.JarLauncher"]
    ports:
     - 8082:8082

  #Vets service
  vets-service:
    image: springcommunity/spring-petclinic-vets-service
    container_name: vets-service
    depends_on:
     - config-server
     - discovery-server
    entrypoint: ["./dockerize","-wait=tcp://discovery-server:8761","-timeout=300s","--","java", "org.springframework.boot.loader.JarLauncher"]
    ports:
     - 8083:8083

  # API gateway
  api-gateway:
    image: springcommunity/spring-petclinic-api-gateway
    container_name: api-gateway
    depends_on:
     - config-server
     - discovery-server
    entrypoint: ["./dockerize","-wait=tcp://discovery-server:8761","-timeout=300s","--","java", "org.springframework.boot.loader.JarLauncher"]
    ports:
     - 8080:8080

  # Admin Server
  # ============================================================================
  admin-server:
    image: springcommunity/spring-petclinic-admin-server
    container_name: admin-server
    depends_on:
     - config-server
     - discovery-server
    entrypoint: ["./dockerize","-wait=tcp://discovery-server:8761","-timeout=300s","--","java", "org.springframework.boot.loader.JarLauncher"]
    ports:
     - 9090:9090

  # Load
  # ============================================================================
  # Load server
  load-server:
    build: ./docker/load-server
    image: springcommunity/load-server
    container_name: load-server
    depends_on:
      - api-gateway
      - customers-service
      - visits-service
      - vets-service
